/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/

/*------------------------------------------------------------------
               SIMPLE FINITE STATE MACHINE ANIMATOR
-------------------------------------------------------------------*/

accept(Sequence):-
	fsm(Name),
	write('Accepting for '), write(Name), write(' Sequence: '), write(Sequence),nl,
	initial_state(I),
	accept(I,Sequence).

accept(S,[]):-
	final_states(FS),
	member(S,FS),!,
	write('Sequence Accepted'),nl,nl.
accept(S,[I|Rest]):-
	transition(S,I,NextS),!,
	accept(NextS,Rest).
accept(_,_):-
	write('Sequence NOT Accepted'),nl,nl.
	
